docker-s3-volume-watch/watch

89 lines
1.4 KiB
Plaintext
Raw Normal View History

2014-08-30 21:16:23 +02:00
#!/bin/bash
2014-11-23 18:51:21 +01:00
[[ "$TRACE" ]] && set -x
2014-08-30 21:16:23 +02:00
function usage {
2014-11-23 18:51:21 +01:00
cat <<-EOF
Usage: $PROGNAME [OPTIONS] <local-path> <remote-path>
Sync s3 directory locally and backup changed files on exit
--force-restore restore even if local directory is not empty
eg: $PROGNAME /data s3://bucket/dir
EOF
2014-08-30 21:16:23 +02:00
}
function error_exit {
echo "${1:-"Unknown Error"}" 1>&2
2014-08-30 21:16:23 +02:00
exit 1
}
2014-11-23 18:51:21 +01:00
PARSED_OPTIONS=$(getopt -n "$0" -o f --long "force-restore" -- "$@")
if [ $? -ne 0 ];
then
exit 1
2014-08-30 21:16:23 +02:00
fi
2014-11-23 18:51:21 +01:00
eval set -- "$PARSED_OPTIONS"
while true;
do
case "$1" in
-f|--force-restore)
FORCE_RESTORE="true"
shift;;
--)
shift
break;;
esac
done
2014-08-30 21:16:23 +02:00
PROGNAME=$0
LOCAL=$1
REMOTE=$2
function restore {
if [ "$(ls -A $LOCAL)" ]; then
2014-11-23 18:51:21 +01:00
if [[ ${FORCE_RESTORE:false} == 'true' ]]; then
error_exit "local directory is not empty"
fi
2014-08-30 21:16:23 +02:00
fi
echo "restoring $REMOTE => $LOCAL"
2014-12-04 06:32:49 +01:00
if ! aws s3 sync "$REMOTE" "$LOCAL"; then
2014-08-30 21:16:23 +02:00
error_exit "restore failed"
fi
}
function backup {
echo "backup $LOCAL => $REMOTE"
if ! aws s3 sync "$LOCAL" "$REMOTE" --delete; then
echo "backup failed" 1>&2
return 1
2014-08-30 21:16:23 +02:00
fi
}
function final_backup {
echo "backup $LOCAL => $REMOTE"
while ! aws s3 sync "$LOCAL" "$REMOTE" --delete; do
echo "backup failed, will retry" 1>&2
sleep 1
done
exit 0
}
2014-08-30 21:16:23 +02:00
function idle {
echo "ready"
while true; do
sleep 42 &
wait $!
done
}
restore
trap final_backup SIGHUP SIGINT SIGTERM
2014-08-30 21:16:23 +02:00
trap "backup; idle" USR1
idle